Light.Spot (JavaFX 19)
Description: declaration: module: javafx.graphics, package: javafx.scene.effect, class: Light, class: Spot

Module javafx.graphics
Package javafx.scene.effect

# Class Light.Spot

java.lang.Object
javafx.scene.effect.Light
javafx.scene.effect.Light.Point
javafx.scene.effect.Light.Spot

Enclosing class:
  Light

public static class Light.Spot extends Light.Point
Represents a spot light source at a given position in 3D space, with configurable direction and focus.

Example:

     Light.Spot light = new Light.Spot();
     light.setX(150);
     light.setY(100);
     light.setZ(80);
     light.setPointsAtX(0);
     light.setPointsAtY(0);
     light.setPointsAtZ(-50);
     light.setSpecularExponent(2);

     Lighting lighting = new Lighting();
     lighting.setLight(light);
     lighting.setSurfaceScale(5.0);

     Text text = new Text();
     text.setText("Spot");
     text.setFill(Color.STEELBLUE);
     text.setFont(Font.font(null, FontWeight.BOLD, 80));
     text.setX(10.0);
     text.setY(10.0);
     text.setTextOrigin(VPos.TOP);
     text.setEffect(lighting);

     Rectangle rect = new Rectangle(200, 150);
     rect.setFill(Color.ALICEBLUE);
     rect.setEffect(lighting);

The code above produces the following:

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final DoubleProperty`
  `pointsAtX`
  The x coordinate of the direction vector for this light.
  `final DoubleProperty`
  `pointsAtY`
  The y coordinate of the direction vector for this light.
  `final DoubleProperty`
  `pointsAtZ`
  The z coordinate of the direction vector for this light.
  `final DoubleProperty`
  `specularExponent`
  The specular exponent, which controls the focus of this light source.

  ### Properties declared in class javafx.scene.effect.Light.Point

  `x, y, z`

  ### Properties declared in class javafx.scene.effect.Light

  `color`

- ## Nested Class Summary

  ## Nested classes/interfaces declared in class javafx.scene.effect.Light

  `Light.Distant, Light.Point, Light.Spot`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Spot()`
  Creates a new instance of Spot light with default parameters.
  `Spot(double x, double y, double z, double specularExponent, Color color)`
  Creates a new instance of Spot light with the specified x, y, z, specularExponent, and color.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final double`
  `getPointsAtX()`
  Gets the value of the property pointsAtX.
  `final double`
  `getPointsAtY()`
  Gets the value of the property pointsAtY.
  `final double`
  `getPointsAtZ()`
  Gets the value of the property pointsAtZ.
  `final double`
  `getSpecularExponent()`
  Gets the value of the property specularExponent.
  `final DoubleProperty`
  `pointsAtXProperty()`
  The x coordinate of the direction vector for this light.
  `final DoubleProperty`
  `pointsAtYProperty()`
  The y coordinate of the direction vector for this light.
  `final DoubleProperty`
  `pointsAtZProperty()`
  The z coordinate of the direction vector for this light.
  `final void`
  `setPointsAtX(double value)`
  Sets the value of the property pointsAtX.
  `final void`
  `setPointsAtY(double value)`
  Sets the value of the property pointsAtY.
  `final void`
  `setPointsAtZ(double value)`
  Sets the value of the property pointsAtZ.
  `final void`
  `setSpecularExponent(double value)`
  Sets the value of the property specularExponent.
  `final DoubleProperty`
  `specularExponentProperty()`
  The specular exponent, which controls the focus of this light source.

  ### Methods declared in class javafx.scene.effect.Light.Point

  `getX, getY, getZ, setX, setY, setZ, xProperty, yProperty, zProperty`

  ### Methods declared in class javafx.scene.effect.Light

  `colorProperty, getColor, setColor`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Property Details

  - ### pointsAtX

    public final DoubleProperty pointsAtXProperty
    The x coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtX()`
      - `setPointsAtX(double)`

  - ### pointsAtY

    public final DoubleProperty pointsAtYProperty
    The y coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtY()`
      - `setPointsAtY(double)`

  - ### pointsAtZ

    public final DoubleProperty pointsAtZProperty
    The z coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtZ()`
      - `setPointsAtZ(double)`

  - ### specularExponent

    public final DoubleProperty specularExponentProperty
    The specular exponent, which controls the focus of this light source.

               Min: 0.0
               Max: 4.0
           Default: 1.0
          Identity: 1.0

    Default value:
      1.0
    See Also:
      - `getSpecularExponent()`
      - `setSpecularExponent(double)`

- ## Constructor Details

  - ### Spot

    public Spot()
    Creates a new instance of Spot light with default parameters.

  - ### Spot

    public Spot(double x, double y, double z, double specularExponent, Color color)
    Creates a new instance of Spot light with the specified x, y, z, specularExponent, and color.
    Parameters:
      `x` - the x coordinate of the light position
      `y` - the y coordinate of the light position
      `z` - the z coordinate of the light position
      `specularExponent` - the specular exponent, which controls the focus of the light source
      `color` - the color of the light
    Since:
      JavaFX 2.1

- ## Method Details

  - ### setPointsAtX

    public final void setPointsAtX(double value)
    Sets the value of the property pointsAtX.
    Property description:
      The x coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### getPointsAtX

    public final double getPointsAtX()
    Gets the value of the property pointsAtX.
    Property description:
      The x coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### pointsAtXProperty

    public final DoubleProperty pointsAtXProperty()
    The x coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtX()`
      - `setPointsAtX(double)`

  - ### setPointsAtY

    public final void setPointsAtY(double value)
    Sets the value of the property pointsAtY.
    Property description:
      The y coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### getPointsAtY

    public final double getPointsAtY()
    Gets the value of the property pointsAtY.
    Property description:
      The y coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### pointsAtYProperty

    public final DoubleProperty pointsAtYProperty()
    The y coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtY()`
      - `setPointsAtY(double)`

  - ### setPointsAtZ

    public final void setPointsAtZ(double value)
    Sets the value of the property pointsAtZ.
    Property description:
      The z coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### getPointsAtZ

    public final double getPointsAtZ()
    Gets the value of the property pointsAtZ.
    Property description:
      The z coordinate of the direction vector for this light.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: n/a

    Default value:
      0.0

  - ### pointsAtZProperty

    public final DoubleProperty pointsAtZProperty()
    The z coordinate of the direction vector for this light.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: n/a

    Default value:
      0.0
    See Also:
      - `getPointsAtZ()`
      - `setPointsAtZ(double)`

  - ### setSpecularExponent

    public final void setSpecularExponent(double value)
    Sets the value of the property specularExponent.
    Property description:
      The specular exponent, which controls the focus of this light source.

                 Min: 0.0
                 Max: 4.0
             Default: 1.0
            Identity: 1.0

    Default value:
      1.0

  - ### getSpecularExponent

    public final double getSpecularExponent()
    Gets the value of the property specularExponent.
    Property description:
      The specular exponent, which controls the focus of this light source.

                 Min: 0.0
                 Max: 4.0
             Default: 1.0
            Identity: 1.0

    Default value:
      1.0

  - ### specularExponentProperty

    public final DoubleProperty specularExponentProperty()
    The specular exponent, which controls the focus of this light source.

               Min: 0.0
               Max: 4.0
           Default: 1.0
          Identity: 1.0

    Default value:
      1.0
    See Also:
      - `getSpecularExponent()`
      - `setSpecularExponent(double)`